// NeoPixel Ring simple sketch (c) 2013 Shae Erisson
// released under the GPLv3 license to match the rest of the AdaFruit NeoPixel library
#include "MemoryFree.h"
#include <Adafruit_NeoPixel.h>
#include "U8glib.h"
U8GLIB_SSD1306_128X64 u8g(U8G_I2C_OPT_NONE|U8G_I2C_OPT_DEV_0);	// I2C / TWI 
#include "knowledge.h"
#include "MyProgmemTools.h"
#include "engine.h"
C_Engine engine=C_Engine();

// http://wiki.bash-hackers.org/scripting/terminalcodes
#define ANSI_NORMAL "\033[0m"
#define ANSI_GREEN "\033[33m\033[42m"
#define ANSI_RED "\033[33m\033[41m"

const char *version="74HCxx-tester-14-16 v.0.4.0";
const char *legs="123456789abcdefghi";
uint8_t verb=1;	// verbosity 0..2
void help(){	// {{{ prints help
	Serial.print(F("Free mem:"));
	Serial.println(freeMemory());
	Serial.println(
		F(" ? help;tT test; v/V verbosity(0..2); l/h all pins; zZ zero; Pv (P=0..9A..G) (v=?lhLH) get(?) or set pin value (lh pulls, LH drives); +- switch 16/14 pins")
		);
}	// }}}

uint8_t pins14[]={2,3,4,5,6,7,8,9,10,11,12,A2};	// 12 I/O pinu na 14 pinove patici (1..6,8..13) , 7=GND, 14=VCC
uint8_t pins16[]={2,3,4,5,6,7,8,9,10,11,12,A2,A0,A1};	// 14 I/O pinu na 16 pinove patici (1..7,9..15) , 8=GND, 16=VCC
// Proc je blbe poradi 12,A2,A0,A1 ? Puvodne to bylo 12,13,A0,A1, ale D13 ma na sobe LED, ktera je pulldown tak silny, ze prebije potrebnych 200k a misto 3.87V ziskam jen 1.38V, coz je L, nikoli H a predratovat to cele by bylo dost obtizne, tak jsem BUTTON_PIN prehodil z A2 na A7
#define DEL 500

#define BUTTON_PIN         A7
// EXTERNAL PULL-UP !!!

#define I2C_SCK            A4
#define I2C_DTA            A5
// Which pin on the Arduino is connected to the NeoPixels?
#define NEO_PIN            A3

// How many NeoPixels are attached to the Arduino?
#define NUMPIXELS      2

// When we setup the NeoPixel library, we tell it how many pixels, and which pin to use to send signals.
// Note that for older NeoPixel strips you might need to change the third parameter--see the strandtest
// example for more information on possible values.
Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUMPIXELS, NEO_PIN, NEO_GRB + NEO_KHZ800);

#define U_LINES 6
#define U_CHARS 16
#define U_LH 10
char u8g_lines[U_LINES][U_CHARS+1];	// jednoducha obrazovka 6 lines, 16 chars (lets hope)
void draw() {	// {{{ graphic commands to redraw the complete screen should be placed here  
	u8g.setFont(u8g_font_unifont);
	// u8g.setFont(u8g_font_osb21);
	// u8g.drawStr( 0, 22, "Hello World!");
	for (uint8_t i=0;i<U_LINES;++i) u8g.drawStr( 0, U_LH*(i+1),u8g_lines[i]);
}	// }}}
void u8g_set_line(uint8_t line, const char *text) {	// {{{ nacpe text na danou radku, kolik jen se vejde
	if (line<0 || line>=U_LINES) return;
	for (uint8_t i=0;i<U_CHARS+1;++i) { 
		if (i == U_CHARS ) { u8g_lines[line][i]=0;return; } 
		else {u8g_lines[line][i]=*text; if (*text==0) return; else text++;};
		};
}	// }}}
void u8g_set_line(uint8_t line, const __FlashStringHelper *text) {	// {{{ nacpe text na danou radku, kolik jen se vejde
	if (line<0 || line>=U_LINES) return;
	const char *t=reinterpret_cast<const char *>(text);
	for (uint8_t i=0;i<U_CHARS+1;++i) { 
		if (i == U_CHARS ) { u8g_lines[line][i]=0;return; } 
		else {u8g_lines[line][i]=pgm_read_byte(FF(t)); if (u8g_lines[line][i]==0) return; else t++;};
		};
}	// }}}
void u8g_clear() {	// {{{ smaze lines
	for (uint8_t i=0;i<U_LINES;++i) u8g_lines[i][0]=0;
} //	}}}
void u8g_redraw() {	// {{{ redraw full screen
	// picture loop
	u8g.firstPage();  
	do {
		draw();
	} while( u8g.nextPage() );
}	// }}}
uint32_t col1,col2, colx;
uint32_t 
	colRed=pixels.Color(255,0,0), 
	colDRed=pixels.Color(8,0,0), 
	colGreen=pixels.Color(0,255,0),
	colBlue=pixels.Color(0,0,255),
	colLBlue=pixels.Color(16,16,255),
	colGray=pixels.Color(16,16,16),
	colYellow=pixels.Color(8,4,2),
	colWhite=pixels.Color(255,255,255);

uint32_t *colBlinks;
bool BlinkState=true;
uint32_t 
	col14[]={colLBlue,colLBlue,colLBlue,colGreen,colLBlue,colRed},
	col12[]={colBlue,colBlue,colBlue,colGreen,colBlue,colRed},
	col00[]={colBlue,colGray,colGray,colGreen,colGray,colRed},
	col595[]={colBlue,colYellow,colYellow,colGreen,colYellow,colRed},
	colUnidetified[]={colDRed,colYellow},
	colLoop[]={colBlue,colLBlue};
	// cols of test/ok/fail

uint16_t drivenOuts=0;		// bitove pole LSB=pin1 ... 1 Sure Output (driven) 
uint16_t knownInputs=0;		// - "" - ... 1 Sure Input (zadan, nebo jeho zmena zpusobi zmenu vystupu)
void reportStatus(uint8_t dlen, uint16_t data, const char *name, const char vals[2] ) {	// {{{ vypise name a za nej data v delce dlen, pricemz bity zobrazi jako vals[0]/vals[1]
	Serial.write(name);
	Serial.println(F(" : "));
	if (verb>0){ for (uint8_t i = (dlen+2)-1; i>=(dlen+2)/2; --i) Serial.write(legs[i]); Serial.println(); };
	Serial.print(F("V"));
	for (uint8_t i =dlen-1; i>=dlen/2; --i) {
		Serial.write(vals[bitRead(data,i)]);
		};
	Serial.println();
	for (uint8_t i =0;i<dlen/2; ++i) {
		Serial.write(vals[bitRead(data,i)]);
		};
	Serial.println(F("G"));
	if (verb>0){ for (uint8_t i =0;i<(dlen+2)/2; ++i) Serial.write(legs[i]); Serial.println(); };
}	// }}}
void SimpleShow (uint8_t dlen, const char outs[2]) {	// {{{ ukaze aktualni hodnoty
	if (verb>0){ for (uint8_t i =(dlen+2)-1; i>=(dlen+2)/2; --i) Serial.write(legs[i]); Serial.println(); };
	Serial.print(F("V"));
	for (uint8_t i=dlen-1;i>=dlen/2;--i) {Serial.write(outs[digitalRead(pins16[i])]);};
	Serial.println();
	for (uint8_t i=0;i<dlen/2;++i) {Serial.write(outs[digitalRead(pins16[i])]);};
	Serial.println(F("G"));
	if (verb>0){ for (uint8_t i =0;i<(dlen+2)/2; ++i) Serial.write(legs[i]); Serial.println(); };
} 	// }}}
////////////////////
void SimpleDump(uint8_t dlen) {	// {{{ jednoradkovy dump stavu pro trasovani
	for (uint8_t i=0;i<dlen;i++){if (i==(dlen>>1)) Serial.print(F(" ")); Serial.write(".#"[digitalRead(pins16[i])]);};
	Serial.println();
}	// }}}
void SimpleTestPull (bool out, uint8_t dlen,uint16_t data, const char ins[2], const char outs[2]) {	// {{{ otestuje kombinaci "data" na zjevne outputy
	for (uint8_t i=0;i<dlen;i++){pinMode(pins16[i],bitRead(data,i)?INPUT_PULLUP:INPUT);};
	for (uint8_t i=0;i<dlen;i++){if (i==(dlen>>1)) Serial.print(F(" "));if (uint8_t(digitalRead(pins16[i]))==bitRead(data,i)) {if(out) Serial.write(ins[bitRead(data,i)]);} else {if(out) Serial.write(outs[!bitRead(data,i)]);bitSet(drivenOuts,i);};};
	if(out) Serial.println();
} 	// }}}
uint16_t getOUTs(uint8_t dlen) {	// {{{ vrati stav znamych outputu, inputy vraci jako 0
	uint16_t retval=0;
	for (uint8_t i=0;i<dlen;i++){ if (bitRead(drivenOuts,i)&&digitalRead(pins16[i])) bitSet(retval,i);};
	return retval;
} 	// }}}
bool test_pull_short (uint8_t dlen) {	// {{{ projde serii rychlych testu ( 000, 111, walking 1, walkink 0) pro zjevne outputy a pak jeste jednou pro zjevne inputy
	Serial.print(F("test_pull_short("));Serial.print(dlen,DEC);Serial.println(F(")"));
	uint32_t *colx= (dlen==12) ? col12:col14;
	colBlinks=colx;
	pixels.setPixelColor(0, colBlinks[0]);
	pixels.setPixelColor(1, colBlinks[1]);
	pixels.show(); // This sends the updated pixel color to the hardware.
	uint16_t data=0;
	if (verb>1) Serial.println(F("all 0:"));
	SimpleTestPull(verb>0,dlen,data,"-^","LH");
	if (verb>1) Serial.println(F("Walking 1:"));
	for (uint8_t i=0;i<dlen;i++){
		data=0;
		SimpleTestPull(verb>0,dlen,bitSet(data,i),"-^","LH");
		};
	data=0xFFFF;
	if (verb>1) Serial.println(F("all 1:"));
	SimpleTestPull(verb>0,dlen,data,"-^","LH");
	if (verb>1) Serial.println(F("Walking 0:"));
	for (uint8_t i=0;i<dlen;i++){
		data=0xFFFF;
		SimpleTestPull(verb>0,dlen,bitClear(data,i),"-^","LH");
		};
	reportStatus(dlen,drivenOuts, "drivenOuts ","-#");
	/////////////////////////////////////////////////////////////////////////////
	uint16_t outs,xouts;
	data=0;
	if (verb>0) Serial.println(F("all 0:"));
	SimpleTestPull(verb>0,dlen,data,"-^","LH");
	outs=getOUTs(dlen);
	if (verb>1) reportStatus(dlen,outs,"out0",".X");
	if (verb>1) Serial.println(F("Walking 1:"));
	for (uint8_t i=0;i<dlen;i++){
		if (bitRead(drivenOuts,i)) continue;
		data=0;
		SimpleTestPull(verb>0,dlen,bitSet(data,i),"-^","LH");
		xouts=getOUTs(dlen);
		if (outs!=xouts) { bitSet(knownInputs,i); 
				if (verb>1) { Serial.print(F("Input = "));Serial.println(i); };
				};
		if (verb>1) reportStatus(dlen,xouts,"get",".X");
		};
	data=0xFFFF;
	if (verb>1) Serial.println(F("all 1:"));
	SimpleTestPull(verb>0,dlen,data,"-^","LH");
	outs=getOUTs(dlen);
	if (verb>1) reportStatus(dlen,outs,"out1",".X");
	if (verb>1) Serial.println(F("Walking 0:"));
	for (uint8_t i=0;i<dlen;i++){
		if (bitRead(drivenOuts,i)) continue;
		data=0xFFFF;
		SimpleTestPull(verb>0,dlen,bitClear(data,i),"-^","LH");
		xouts=getOUTs(dlen);
		if (outs!=xouts){ bitSet(knownInputs,i);
				if (verb>1) {Serial.print(F("Input = "));Serial.println(i);};
				};
		if (verb>1) reportStatus(dlen,xouts,"get",".X");
		};
	reportStatus(dlen,drivenOuts, "drivenOuts ","-#");
	reportStatus(dlen,knownInputs,"knownInputs","-#");
	bool retval=true;
	Serial.print(F("Result pins:"));
	for  (uint8_t i=0;i<dlen;i++){ 
		if (i==(dlen>>1)) Serial.print(F(" "));
		if ( bitRead(drivenOuts,i)) Serial.print(F("O"));
		else if ( bitRead(knownInputs,i)) Serial.print(F("i"));
		else {
			Serial.print(F("?"));
			retval=false;
			};
		};
	if (retval) Serial.println(F(" - Chip pins recognized")); 
	else { 
		Serial.println(F(" - some chip pins mysterious"));
		Serial.print(F("if (drivenOuts==0b"));
		for  (int8_t i=dlen;i>=0;i--) Serial.write(bitRead(drivenOuts,i)?"1":"0");
		Serial.print(F(" && knownInputs==0b"));
		for  (int8_t i=dlen;i>=0;i--) Serial.write(bitRead(knownInputs,i)?"1":"0");
		Serial.println(F(") {"));
	};
	colBlinks=&colx[retval?2:4];
	pixels.setPixelColor(0, colBlinks[0]);
	pixels.setPixelColor(1, colBlinks[1]);
	pixels.show(); // This sends the updated pixel color to the hardware.
	for (uint8_t i=0;i<2;i++){
		delay(DEL); // Delay for a period of time (in milliseconds).
	};
	return retval;

} 	// }}}
///////////////////////////////
uint8_t dlen=12;
int bank=0;

void setup() {	
	{ // {{{ std setup
		for (uint8_t i=0;i<14;i++) {
			pinMode(pins16[i],INPUT);
			};
		for (uint8_t i=0;i<12;i++) {
			pinMode(pins14[i],INPUT);	// trochu zbytecne, uz se stalo 14 je casti 16
			};
		
		pinMode(BUTTON_PIN,INPUT);	// external pullup
		
		pixels.begin(); // This initializes the NeoPixel library.
		for (uint8_t i=0;i<NUMPIXELS;i++) {
			pixels.setPixelColor(i, colWhite);
			}
		pixels.show(); // This sends the updated pixel color to the hardware.
	}; // }}}
	// {{{ u8g I2C screen
	// flip screen, if required
	// u8g.setRot180();

	// set SPI backup if required
	//u8g.setHardwareBackup(u8g_backup_avr_spi);

	// assign default color value
	if ( u8g.getMode() == U8G_MODE_R3G3B2 ) {
		u8g.setColorIndex(255);     // white
	}
	else if ( u8g.getMode() == U8G_MODE_GRAY2BIT ) {
		u8g.setColorIndex(3);         // max intensity
	}
	else if ( u8g.getMode() == U8G_MODE_BW ) {
		u8g.setColorIndex(1);         // pixel on
	}
	else if ( u8g.getMode() == U8G_MODE_HICOLOR ) {
		u8g.setHiColorByRGB(255,255,255);
	}
	// }}}
	u8g_clear();
	u8g_set_line(0,version);
	u8g_set_line(1,&version[U_CHARS]);
	u8g_set_line(2,"");
	u8g_set_line(3,"(in setup)");
	u8g_set_line(4,"Press key !!");
	u8g_redraw();
	Serial.begin(9600);
	//Serial.begin(115200);
	Serial.println(version);
	// dump database:
	for (uint16_t u=0;u<number_of_units-1;u++) {
		Serial.print(engine.get_unit_name(u));
		Serial.print(F(" : "));
		Serial.println(engine.get_unit_comment(u));
	};
	help();
//	engine.milestone("engine created");
	Serial.print(dlen+2);
	Serial.print(F(">"));

}
bool do_test=false;
uint8_t loopval=0;
void fulltest() { // {{{
		u8g_clear();
		u8g_set_line(0,version);
		u8g_set_line(1,"");
		u8g_set_line(2,"TESTING ...");
		u8g_set_line(4,"");
		u8g_set_line(5,"");
		u8g_redraw();
	uint32_t *colx= col00;
	colBlinks=colx;
	pixels.setPixelColor(0, colBlinks[0]);
	pixels.setPixelColor(1, colBlinks[1]);
	pixels.show(); // This sends the updated pixel color to the hardware.
	bool ok=true;
	drivenOuts=0;knownInputs=0;
	test_pull_short(14);
	engine.reset(14+2,drivenOuts,knownInputs);
	if (engine.run_range(&units[0],&units[number_of_units-1])) {
		Serial.println(F(ANSI_GREEN "Chip OK" ANSI_NORMAL));
		u8g_clear();
		u8g_set_line(0,version);
		u8g_set_line(1,"");
		u8g_set_line(2,engine.get_unit_name());
		u8g_set_line(4,engine.get_unit_comment());
		u8g_set_line(5,"Press key !!");
		u8g_redraw();
	} else {
		engine.reset(12+2,drivenOuts,knownInputs);
		if (engine.run_range(&units[0],&units[number_of_units-1])) {
			Serial.println(F(ANSI_GREEN "Chip OK" ANSI_NORMAL));
			u8g_clear();
			u8g_set_line(0,version);
			u8g_set_line(1,"");
			u8g_set_line(2,engine.get_unit_name());
			u8g_set_line(4,engine.get_unit_comment());
			u8g_set_line(5,"Press key !!");
			u8g_redraw();
		} else {
			ok=false;
			Serial.println(F(ANSI_RED "Chip FAILED" ANSI_NORMAL));
			u8g_clear();
			u8g_set_line(0,version);
			u8g_set_line(1,"");
			u8g_set_line(2,"????? ");
			u8g_set_line(4," Not found");
			u8g_set_line(5,"Press key !!");
			u8g_redraw();
		};
	};
	colBlinks=&colx[ok?2:4];
	pixels.setPixelColor(0, colBlinks[0]);
	pixels.setPixelColor(1, colBlinks[1]);
	pixels.show(); // This sends the updated pixel color to the hardware.
	for (uint8_t i=0;i<2;i++){
		delay(DEL); // Delay for a period of time (in milliseconds).
	};
} // }}}
void loop() {
	if (loopval) colBlinks= colUnidetified;
	if (loopval) --loopval;
	else colBlinks= colLoop;
	pixels.setPixelColor(0, colBlinks[BlinkState]);
	pixels.setPixelColor(1, colBlinks[!BlinkState]);
	if ( analogRead(BUTTON_PIN)>512 ) {do_test=true;} 
	else { 
		if (do_test) fulltest();
		do_test=false;
		};
	if (Serial.available()>0) {
		char c1;
		int z;
		z = Serial.read();
		Serial.write(z);
		c1=z;
		if (c1=='@'||c1=='@') {
			engine.filter_by_mask= !engine.filter_by_mask; 
			if (engine.filter_by_mask) Serial.println(F("engine FILTERED")); else Serial.println(F("engine UNfiltered"));
		} else
		if (c1=='$'||c1=='$') {
			engine.run_all_lines = !engine.run_all_lines; 
			if (engine.run_all_lines) Serial.println(F("engine run_all_lines")); else Serial.println(F("engine NOT run_all_lines"));
		} else
		if (c1=='@'||c1=='@') {
			engine.filter_by_mask= !engine.filter_by_mask; 
			if (engine.filter_by_mask) Serial.println(F("engine FILTERED")); else Serial.println(F("engine UNfiltered"));
		} else
		if (c1=='#'||c1=='#') {
			++engine.verbosity;
			if (engine.verbosity >= E_VERBOSITY_max) engine.verbosity = E_VERBOSITY_min;
			engine.do_log(engine.verbosity,F("engine.verbosity"));
		} else
		if (c1=='!'||c1=='!') {
			// prelimitary test, should be in engine anyway
			drivenOuts=0;knownInputs=0;
			test_pull_short(14);
			engine.reset(dlen+2,drivenOuts,knownInputs);
			engine.run_range(&units[0],&units[number_of_units-1]);
//			engine.milestone("engine tested");
			help();

			
		} else
		if (c1==' '||c1=='?') help(); else
		if (c1=='t'||c1=='T') fulltest(); else
		if (c1=='v') { if (verb>0) --verb;Serial.print(F(" verbosity = "));Serial.println(verb);} else
		if (c1=='V') { if (verb<2) ++verb;Serial.print(F(" verbosity = "));Serial.println(verb);} else
		if (c1=='+') { dlen=14;Serial.println();} else
		if (c1=='-') { dlen=12;Serial.println();} else
		if (c1=='l'||c1=='h') { 
			for (uint8_t i=0;i<14;i++) {
				pinMode(pins16[i],(c1=='l')?INPUT:INPUT_PULLUP);
				};
		} else
		if (c1=='z'||c1=='Z') {drivenOuts=0;knownInputs=0;} else
		if (((c1>='1') && (c1<='9')) || (c1>='A' && c1<='G')|| (c1>='a' && c1<='g')) { 
			int x,l;
			x=0;
			l=0;
			if ((c1>='1') && (c1<='9')) l=c1-'0'; else if  (c1>='A' && c1<='G') l=(c1-'A')+10;  else if  (c1>='a' && c1<='g') l=(c1-'a')+10;
			--l; //indexujeme od nuly
			Serial.print(F("Leg["));Serial.print(l);Serial.print(F("]="));Serial.print(legs[l]);Serial.print(F("; "));
			x=l;
			if (x >= dlen/2) --x;	// GND preskakujeme
			while (Serial.available()<1) ;
			z=Serial.read();
			c1=z;
			Serial.write(c1);
			Serial.print(F(" "));
			switch (c1) {
				case 'h': pinMode(pins16[x],INPUT_PULLUP);Serial.print(legs[l]);Serial.println(F("=h"));break;
				case 'l': pinMode(pins16[x],INPUT);Serial.print(legs[l]);Serial.println(F("=l"));break;
				case 'H': pinMode(pins16[x],OUTPUT);digitalWrite(pins16[x],1);Serial.print(legs[l]);Serial.println(F("=H"));break;
				case 'L': pinMode(pins16[x],OUTPUT);digitalWrite(pins16[x],0);Serial.print(legs[l]);Serial.println(F("=L"));break;
				case '?': pinMode(pins16[x],INPUT);c1='0'+digitalRead(pins16[x]);Serial.print(legs[l]);Serial.print(F("="));Serial.println(c1);break;
				default:  Serial.println(F("?"));break;
				};
				}
			else Serial.println(F("?"));
		SimpleShow(dlen,"-#");
		Serial.print(dlen+2);
		Serial.print('>');
		}
	{ // {{{ std suffix
	pixels.show(); // This sends the updated pixel color to the hardware.
	delay(DEL); // Delay for a period of time (in milliseconds).
	BlinkState = !BlinkState;
	}; // }}}
}
