#!/usr/bin/python -u
# vim: fileencoding=utf-8:nomodified:nowrap:textwidth=0:foldmethod=marker:foldcolumn=4:ruler:showcmd:lcs=tab\:|- list:noexpandtab:nosmarttab:softtabstop=0:shiftwidth=0

import sys,os
import datetime
# {{{ decoder
decoder={
#	index	:( bank0	bank1	bank2 (^0x80 if char)
	0x0	: ( '\0',	'\0',	'\0' ),	#	'eoln, Bank 0'
	0x1	: ( 'x',	'N',	'a' ),	# bank2 shifted by 0x80 here vvv
	0x2	: ( 'v',	'I',	'A' ),
	0x3	: ( '^',	'O',	'b' ),
	0x4	: ( 'L',	'G',	'B' ),
	0x5	: ( 'H',	'V',	'c' ),
	0x6	: ( '0',	'3',	'C' ),
	0x7	: ( '1',	'%',	'd' ),
	0x8	: ( 'c',	'X',	'D' ),	# bank2 shifted by 0x80 here ^^^
	0x9	: ( 'C',	'F',	' ' ),
	0xa	: ( 'e',	' ',	' ' ),
	0xb	: ( 'E',	' ',	' ' ),
	0xc	: ( 'Z',	' ',	' ' ),
	0xd	: ( 'R',	' ',	' ' ),
	0xe	: ( chr(0xFE),	chr(0xFE),	chr(0xFE) ),	#	'Shift bank <-'
	0xF	: ( chr(0xFF),	chr(0xFF),	chr(0xFF) ),	#	'Shift bank ->'
	}
# }}}
class compile_knowledge():
	def setup(self):	 # {{{ open files and write headers or terminate with fail
		""" setup and open files """
		print sys.argv
		if (len(sys.argv) != 3):
			print "%s output_base input_file.txt" % sys.argv[0]
			sys.exit(1)
		(basename,self.infile_name)=sys.argv[1:3]
		self.outfile_name_h="%s.h"%basename
		(self.outfile_name_units,self.outfile_name_lines,self.outfile_name_names,self.outfile_name_comments,self.outfile_name_decoder)=[ "%s_%s.cpp"%(basename,c) for c in ("units","lines","names","comments","decoder")]
		self.infile=open(self.infile_name,"r")
		self.outfile_units=open(self.outfile_name_units,"w")
		self.outfile_lines=open(self.outfile_name_lines,"w")
		self.outfile_names=open(self.outfile_name_names,"w")
		self.outfile_comments=open(self.outfile_name_comments,"w")
		self.outfile_decoder=open(self.outfile_name_decoder,"w")
		self.outfile_h=open(self.outfile_name_h,"w")
		self.outfile_units.write(
"""//////////////////////
// vim: fileencoding=utf-8:nomodified:nowrap:textwidth=0:foldmethod=marker:foldcolumn=4:ruler:showcmd:lcs=tab\:|- list:noexpandtab:nosmarttab:softtabstop=0:shiftwidth=0
// Generated %s from %s
//////////////////////
"""%(datetime.datetime.now().strftime("%Y.%m.%d %H:%M:%S"),self.infile_name))
		self.outfile_units.write(
"""
#include \"%s\"
#include <avr/pgmspace.h>

const S_Unit units[]={
""" %self.outfile_name_h
)
		self.outfile_lines.write(
"""//////////////////////
// vim: fileencoding=utf-8:nomodified:nowrap:textwidth=0:foldmethod=marker:foldcolumn=4:ruler:showcmd:lcs=tab\:|- list:noexpandtab:nosmarttab:softtabstop=0:shiftwidth=0
// Generated %s from %s
//////////////////////
"""%(datetime.datetime.now().strftime("%Y.%m.%d %H:%M:%S"),self.infile_name))
		self.outfile_lines.write(
"""
#include \"%s\"
#include <avr/pgmspace.h>

const PROGMEM S_Line lines[]={
	""" %self.outfile_name_h
)
		self.outfile_names.write(
"""//////////////////////
// vim: fileencoding=utf-8:nomodified:nowrap:textwidth=0:foldmethod=marker:foldcolumn=4:ruler:showcmd:lcs=tab\:|- list:noexpandtab:nosmarttab:softtabstop=0:shiftwidth=0
// Generated %s from %s
//////////////////////
"""%(datetime.datetime.now().strftime("%Y.%m.%d %H:%M:%S"),self.infile_name))
		self.outfile_names.write(
"""
#include \"%s\"
#include <avr/pgmspace.h>

const PROGMEM char names[]={
	""" %self.outfile_name_h
)
		self.outfile_comments.write(
"""//////////////////////
// vim: fileencoding=utf-8:nomodified:nowrap:textwidth=0:foldmethod=marker:foldcolumn=4:ruler:showcmd:lcs=tab\:|- list:noexpandtab:nosmarttab:softtabstop=0:shiftwidth=0
// Generated %s from %s
//////////////////////
"""%(datetime.datetime.now().strftime("%Y.%m.%d %H:%M:%S"),self.infile_name))
		self.outfile_comments.write(
"""
#include \"%s\"
#include <avr/pgmspace.h>

const PROGMEM char comments[]={
""" %self.outfile_name_h
)
		self.outfile_decoder.write(
"""//////////////////////
// vim: fileencoding=utf-8:nomodified:nowrap:textwidth=0:foldmethod=marker:foldcolumn=4:ruler:showcmd:lcs=tab\:|- list:noexpandtab:nosmarttab:softtabstop=0:shiftwidth=0
// Generated %s from %s
//////////////////////
"""%(datetime.datetime.now().strftime("%Y.%m.%d %H:%M:%S"),self.infile_name))
		self.outfile_decoder.write(
"""
#include \"%s\"
#include <avr/pgmspace.h>

const char line_decoder[][16]=
	{ 
""" %self.outfile_name_h
)
		self.outfile_decoder.write('\t\t{')
		self.outfile_decoder.write(', '.join(["0x%X"%ord(d) for d in [decoder[i][0] for i in  range(16)]]))
		self.outfile_decoder.write('},\n\t\t{')
		self.outfile_decoder.write(', '.join(["0x%X"%ord(d) for d in [decoder[i][1] for i in  range(16)]]))
		self.outfile_decoder.write('},\n\t\t{')
		self.outfile_decoder.write(', '.join(["0x%X"%((ord(d)^0x80) if d >' ' and d<=chr(127) else ord(d)) for d in [decoder[i][2] for i in  range(16)]]))
		self.outfile_decoder.write('},\n\t};\n')
		self.outfile_decoder.write("// line_decoder :\n")
		self.outfile_decoder.write("//\t%X\t0x%X\t0x%X\t0x%X	// eoln\n"%(0, ord(decoder[0][0]) ,ord(decoder[0][1]), ord(decoder[0][2])))
		for i in  range(1,14):
			self.outfile_decoder.write("//\t%X\t'%s'\t'%s'\t'%s'\n"%(i, decoder[i][0] ,decoder[i][1],('@%s' if decoder[i][2]!=' ' else '%s')%decoder[i][2]))
		self.outfile_decoder.write("//\t%X\t0x%X\t0x%X\t0x%X	// Shift bank <-\n"%(14, ord(decoder[14][0]) ,ord(decoder[14][1]),ord(decoder[14][2])))
		self.outfile_decoder.write("//\t%X\t0x%X\t0x%X\t0x%X	// Shift bank ->\n"%(15, ord(decoder[15][0]) ,ord(decoder[15][1]),ord(decoder[15][2])))
		
		self.outfile_h.write(
"""//////////////////////
// vim: fileencoding=utf-8:nomodified:nowrap:textwidth=0:foldmethod=marker:foldcolumn=4:ruler:showcmd:lcs=tab\:|- list:noexpandtab:nosmarttab:softtabstop=0:shiftwidth=0
// Generated %s from %s
//////////////////////
"""%(datetime.datetime.now().strftime("%Y.%m.%d %H:%M:%S"),self.infile_name))
		self.outfile_h.write(
"""
#ifndef KNOWLEDGE_H
#define KNOWLEDGE_H

// for uint*_t
#include <stdint.h>
#include <avr/pgmspace.h>


/*
struct S_Line {
	uint8_t eline[16];	// direct line
// encoded line of 16 halfbytes is not possible - too many values
	};
*/
# define S_Line char
struct S_Unit {
	const char *name;
	const char *comment;
	const S_Line *start;
	const S_Line *end;	// this is START of NEXT unit, does not belong to me
	uint16_t test_inputs,test_inputs_mask;
	uint16_t test_outputs,test_outputs_mask;
	uint8_t TP;	// Total pins: 14/16 
	uint8_t AP;	// Active pins: 12/14
	};
extern const char line_decoder[][16];	// decoding halfbytes to chars, defined in %s.cpp
extern const PROGMEM S_Line lines[];
extern const S_Unit units[];
extern const uint16_t number_of_units;
extern const PROGMEM char names[];
extern const PROGMEM char comments[];
	
""" %self.outfile_name_decoder
		)
		
		self.in_comm=False
		self.line_no=0
		self.cpp_lines_num=0
		self.cpp_names_num=0
		self.cpp_comments_num=0
		self.cpp_units_num=0
	# }}}
	def finish(self): 	# {{{ Close files
		self.outfile_h.write(
"""
#endif
"""
		)
		self.outfile_units.write(
"""
};

const uint16_t number_of_units=%s;

// The End :)
"""
		 % self.cpp_units_num )
		self.outfile_lines.write(
"""
	0};

// The End :)
"""
		)
		self.outfile_names.write(
"""
// [%s]
	"\\0"};
// The End :)
"""%self.cpp_names_num
		)
		self.outfile_comments.write(
"""
// [%s]
	"\\0"};
// The End :)
"""%self.cpp_comments_num
		)
		self.outfile_decoder.write(
"""
// The End :)
"""
		)
		self.outfile_units.close()
		self.outfile_lines.close()
		self.outfile_names.close()
		self.outfile_comments.close()
		self.outfile_decoder.close()
		self.outfile_h.close()
		self.infile.close();
	# }}}
	def line_encode(self,x):	 # {{{ returns line compacted
		#	return ''.join([ "'%s',"%c for c in x])
		retval=[]
		lsb=True
		b=0
		bank=0
		for c in x:
			found=False
			for i,v in decoder.iteritems():
				for j in range(len(v)):
					if c==v[j]:
						if j!=bank:
							shift= 0xF if (j==bank+1 or j==bank-2) else 0xE
							b*=16
							b+=shift	# Shift
							lsb = not lsb
							if lsb:
								retval+=("0x%02X, "%b,)
								b=0
							bank = j
						b*=16
						b+=i
						found=True
						break
			if not found:
				print "Error: Cannot encode 0x%X '%s' found at %s +%s"%(ord(c),c,self.infile_name,self.line_no)
				sys.exit(1)
			lsb = not lsb
			if lsb:
				retval+=("0x%02X, "%b,)
				b=0
		b*=16
		b+=0x0	# eoln
		lsb = not lsb
		if not lsb:
			b*=16
			b+=0x0	# eoln
			lsb = not lsb
		if lsb:
			lsb = not lsb
			retval+=("0x%02X, "%b,)
			b=0
		return ''.join(retval)
	# }}}
	def clean_line(self,line):	 # {{{ clean komments, whitespaces, returns good line or False
		""" clean komments, whitespaces, returns good line or False """
		self.line_no+=1
		if self.in_comm:
			lp2=line.find("*/")
			if lp2>-1:
				line=line[lp2+2:]
				self.in_comm=False
			else:
				return False
		line=line.strip()
		lp=line.find("//")
		if lp>-1:
			lp2=line.find("/*")
			if (lp2>lp or lp2<0):
				line=line[:lp].strip()
		lp=line.find("/*")
		lp2=line.find("*/")
		if (lp2>-1 and (lp<0 or lp>lp2)):
			print "Error: '*/' found at %s +%s"%(self.infile_name,self.line_no)
			sys.exit(1)
		while lp>-1:
			lp2=line.find("*/")
			if lp2>-1:
				line="\t".join([line[:lp],line[lp2+2:]]).strip()
			else:
				line=line[:lp].strip()
				self.in_comm=True
			lp=line.find("//")
			if lp>-1:
				lp2=line.find("/*")
				if (lp2>lp or lp2<0):
					line=line[:lp].strip()
			lp=line.find("/*")
		if len(line)==0: return False
		return line
		
	# }}}
	def main(self):	 # {{{
		""" main function """
		self.setup()
		for i in range(1,15):
			if ord(decoder[i][2])>ord(' ') and ord(decoder[i][2])<=127: 
				decoder[i]=(decoder[i][0],decoder[i][1],chr(ord(decoder[i][2])^0x80))
#				decoder[i][2]=chr(ord(decoder[i][2])+0x80)
		unit=None
		first=True
		for line in self.infile:
			line=self.clean_line(line)
			if not line: continue
			if line[0]==":":	# {{{
				if not unit:
					print "Error: 'line out of unit' found at %s +%s"%(self.infile_name,self.line_no)
					sys.exit(1)
				hdr=line[1:].strip().split()
				if len(hdr)!=2:
					print "Error: 'malformed :line (no space)' found at %s +%s"%(self.infile_name,self.line_no)
					sys.exit(1)
				if hdr[0] == "size": 
					unit.size=int(hdr[1])
					unit.TP=unit.size
				elif hdr[0] == "test_inputs": 
					unit.set_test_inputs(hdr[1])
				elif hdr[0] == "test_outputs": 
					unit.set_test_outputs(hdr[1])
				elif hdr[0] == "pins": 
					line = hdr[1].strip()
					# just output special line for now FIXME
					if unit.AP==0 or unit.TP==0:
						if not unit.AP: unit.AP=len(line.replace("G","").replace("V","").replace("P","").replace("@",""))
						if not unit.TP: unit.TP=len(line)
					else:
						print "Error: 'pins already defined at :pins' found at %s +%s"%(self.infile_name,self.line_no)
						sys.exit(1)
					outline=self.line_encode(line_normalize(line))
					self.outfile_lines.write(outline)
					self.cpp_lines_num+=len(outline)/6
					self.outfile_lines.write("\t // [%s] %s\n\t"%(self.cpp_lines_num-1,line))
				else:
					print "Error: 'malformed :line (bad name)' found at %s +%s"%(self.infile_name,self.line_no)
					sys.exit(1)
				# }}}
			elif line[0]=="=":	# {{{
				if unit:
					unit.end=self.cpp_lines_num
					if first:
						first=False
						self.outfile_units.write(" ")
					else:
						self.outfile_units.write(",")
					if not (unit.export(self.outfile_units)):
						print "Error: 'malformed unit - no pins '%s' [%s] in  %s"%(unit.name,unit.number,self.infile_name)
						sys.exit(1)
				else:
					self.outfile_units.write(" ")
				hdr=line.strip("=").strip().split(' ',1)
				unit=cpp_unit()
				unit.number=self.cpp_units_num
				self.cpp_units_num+=1
				if len(hdr)==2:
					unit.name,unit.comment=hdr
				else:
					unit.name=hdr[0]
					unit.comment=hdr[0]
				unit.name_num=self.cpp_names_num
				unit.comment_num=self.cpp_comments_num
				unit.start=self.cpp_lines_num
				self.outfile_lines.write("\n// unit[%s]: '%s' '%s'\n// [%s]\n\t"%(unit.number,unit.name,unit.comment,self.cpp_lines_num))
				self.outfile_names.write("\"%s\\0\" // unit[%s]: '%s' '%s'\n// [%s]\n\t"%(unit.name,unit.number,unit.name,unit.comment,self.cpp_lines_num))
				self.outfile_comments.write("// [%s]\n\t\"%s\\0\" // unit[%s]: '%s'\n"%(self.cpp_lines_num,unit.comment,unit.number,unit.name))
				self.cpp_names_num+=len(unit.name)+1
				self.cpp_comments_num+=len(unit.comment)+1
				# }}}
			else:	# {{{
				if not unit:
					print "Error: 'line out of unit' found at %s +%s"%(self.infile_name,self.line_no)
					sys.exit(1)
				if unit.AP==0 or unit.TP==0:
					if not unit.AP: unit.AP=len(line.replace("G","").replace("V","").replace("P","").replace("@",""))
					if not unit.TP: unit.TP=len(line)
				outline=self.line_encode(line_normalize(line))
				self.outfile_lines.write(outline)
				self.cpp_lines_num+=len(outline)/6
				self.outfile_lines.write("\t // [%s] %s\n\t"%(self.cpp_lines_num-1,line))
				# }}}
			
#			self.utfile_cpp.write("//%s\n\t"%line)
		if unit.start>self.cpp_lines_num:
			unit.start=0
			unit.end=0
		else:
			unit.end=self.cpp_lines_num
		self.outfile_units.write(",")
		if not (unit.export(self.outfile_units)):
			print "Error: 'malformed unit - no pins '%s' [%s] in  %s"%(unit.name,unit.number,self.infile_name)
			sys.exit(1)
		self.finish()

	# }}}
class cpp_unit(object):	 # {{{
	""" one unit """
	def __init__(self):	 # {{{
		self.name="??"
		self.comment="??"
		self.start=0
		self.end=0
		self.test_inputs=0
		self.test_inputs_mask=0
		self.test_outputs=0
		self.test_outputs_mask=0
		self.TP=0
		self.AP=0
		self.number=0
	# }}}
	def export(self,f):	 # {{{
#		print self.__dict__
		f.write("\n\n// unit[%d] "%self.number)
		f.write("'%s' '%s'\n"%(self.name,self.comment))
		f.write("\n{")
		if not (self.TP and self.AP) and (self.start >= self.end): 
			f.write("	.name=0,\n")
			f.write("	.comment=0,\n")
			f.write("	.start=0,\n")
			f.write("	.end=0,\n")
		else:
			f.write("	.name=&names[%d], // '%s'\n"%(self.name_num,self.name))
			f.write("	.comment=&comments[%d], // '%s'\n"%(self.comment_num,self.comment))
			f.write("	.start=&lines[%d],\n"%self.start)
			f.write("	.end=&lines[%d],\n"%self.end)
		f.write("	.test_inputs=0x%X,\n"%self.test_inputs)
		f.write("	.test_inputs_mask=0x%X,\n"%self.test_inputs_mask)
		f.write("	.test_outputs=0x%X,\n"%self.test_outputs)
		f.write("	.test_outputs_mask=0x%X,\n"%self.test_outputs_mask)
		f.write("	.TP=%d,\n"%self.TP)
		f.write("	.AP=%d\n"%self.AP)
		f.write("}\n")
		if not (self.TP and self.AP) and (self.start < self.end ): return False
		return True
	# }}}
	def set_test_inputs(self,x):	 # {{{
		self.test_inputs=to_bin(x,yes="I#1")
		self.test_inputs_mask=to_bin(x,no="X")
	# }}}
	def set_test_outputs(self,x):	 # {{{
		self.test_outputs=to_bin(x,yes="O#1")
		self.test_outputs_mask=to_bin(x,no="X")
	# }}}
	
# }}}
def to_bin(x,yes=False,no=False):	 # {{{ Converts string to binary number from left=LSB; one of yes/no is string of chars for this value, rest is the other
	retval=0
	val=1
	if yes:
		for c in x:
			if c in yes: retval+=val
			val*=2
		return retval
	if no:
		for c in x:
			if not c in no: retval+=val
			val*=2
		return retval
	return 0
# }}}
def line_normalize(x):	 # {{{ Set all variants to canonical ones
	while (-1<x.find("@")):	# bank 3
		p=x.find("@")
		z=x[p+1]
#		x[p:p+1]=chr(128+ord(z))
		x=chr(128+ord(z)).join((x[:p],x[p+2:]))
#		x=x.replace('@',1)
	return x.replace("-","v").replace("_","v").replace(".","v").replace("#","^").replace("!","^").replace("+","^").replace("3","Z").replace("B","%")
# }}}
compile_knowledge().main()
