#include "engine.h"
#include <avr/pgmspace.h>
T_Bus def_pins={2,3,4,5,6,7,8,9,10,11,12,A2,A0,A1,0xFF,0xFF};
// {{{ NOTODOS NOLATERS
#ifdef NOTODOS
#define TODO(x)
#else
#define DO_PRAGMA(x) _Pragma (#x)
#define TODO(x) DO_PRAGMA(message ("TODO: " #x))
#endif
#ifdef NOLATERS
#define LATER(x)
#else
#define DO_PRAGMA(x) _Pragma (#x)
#define LATER(x) DO_PRAGMA(message ("LATER: " #x))
#endif
// }}}
// {{{ C_decoder
C_decoder::C_decoder(C_Engine * logger):offset(0),logger(logger){};	// thats it
uint8_t C_decoder::fill(const char *&start, char *target) {	// {{{ fill target with decoded start, = num of chars
	offset=0;
	// loop
	uint8_t h,l;
	int8_t bank=0;
//#	char c;
//#	Serial.print(F("C_decoder::fill("));
//#	Serial.print((long unsigned int)start,HEX);
//#	Serial.print(F("->"));
//#	Serial.print((long unsigned int)target,HEX);
	while (true) {	// loops over char till the end of line (decoded value 0x00)
//#	Serial.print(F(":"));
		h=*(start++);
//#	Serial.print(h,HEX);
//#	Serial.print(F("="));
		l=h & 0x0F;
		h >>= 4;
		for (uint8_t i=0;i<2;i++){	// 2 halfbytes
			h=line_decoder[bank][h];
			if (h==0xFE) {--bank; if (bank<0) bank=2;
//#	Serial.print(F("bank--"));
				} else 	// bank switching does not change anything
			if (h==0xFF) {++bank; if (bank>2) bank=0;
//#	Serial.print(F("bank++"));
			} else
			if (h==0) { *(target++)=h; ++offset; 
//#	Serial.print(F("EOLN"));
			return offset-1;} else	// end of line	(no need inc target or offset, but.. anyway)
			{ *(target++)=h; ++offset; // just store decoded result
//#	c=h;if (c>127){ Serial.write("@"); c&=0x7F;};Serial.write(c);
//#	Serial.write("|");
			};
			h=l;
		};
	};
	// cannot get here
}; 	// }}}
uint8_t C_decoder::fillP(const char *&start, char *target) {	// {{{ fill target with decoded start from PROGMEM, = num of chars
	offset=0;
//	logger->debug(F("fillP: offset"),offset);
	// loop
	uint8_t h,l;
	int8_t bank=0;
//#	char c;
//#	Serial.print(F("C_decoder::fill("));
//#	Serial.print((long unsigned int)start,HEX);
//#	Serial.print(F("->"));
//#	Serial.print((long unsigned int)target,HEX);
	while (true) {	// loops over char till the end of line (decoded value 0x00)
//#	Serial.print(F(":"));
		h=pgm_read_byte(start);
		++start;
//#	Serial.print(h,HEX);
//#	Serial.print(F("="));
		l=h & 0x0F;
		h >>= 4;
		for (uint8_t i=0;i<2;i++){	// 2 halfbytes
			h=line_decoder[bank][h];
			if (h==0xFE) {--bank; if (bank<0) bank=2;
//#	Serial.print(F("bank--"));
				} else 	// bank switching does not change anything
			if (h==0xFF) {++bank; if (bank>2) bank=0;
//#	Serial.print(F("bank++"));
			} else
			if (h==0) { *(target++)=h; ++offset; 
//#	Serial.print(F("EOLN"));
			return offset-1;} else	// end of line	(no need inc target or offset, but.. anyway)
			{ *(target++)=h; ++offset; // just store decoded result
//			logger->debug(F("fillP: store offset"),offset);
//#	c=h;if (c>127){ Serial.write("@"); c&=0x7F;};Serial.write(c);
//#	Serial.write("|");
			};
			h=l;
		};
	};
	// cannot get here
}; 	// }}}
// }}} C_decoder
// {{{ C_Engine
C_Engine::C_Engine():	// {{{ constructor
	unit(NULL),line(NULL),unit_no(0),unit_skipped(0),unit_failed(0),line_no(0)
	,decoder(new C_decoder(this))
	,do_extra_tests(true),filter_by_mask(true),log_targets(TG_ALL),verbosity(V_MILESTONE)
	,num_pins(BUS_LEN),num_active_pins(BUS_LEN-2),num_NC_pins(0)
	{
	for (uint8_t i=0;i<BUS_LEN;i++) pins[i]=def_pins[i];
	// 14 I/O pinu na 16 pinove patici (1..7,9..15) , 8=GND, 16=VCC
};	// }}}
const char PROGMEM Levels[E_VERBOSITY_max][10]={	// {{{
	"NONE",
	"ERROR",
	"MILESTONE",
	"INFO",
	"DEBUG",
	"TRACE",
	"ALL"
};	// }}}
//	{{{ LOGGING
bool C_Engine::do_log(uint8_t lvl,const char *msg) { 	// {{{ logging also line and unit and result
	if (verbosity<lvl) return false;
	if (log_targets & TG_LED) /* LED=RED TODO */;
LATER("logging to LED")
	if (log_targets & TG_SERIAL) {
		Serial.print(FF(Levels[lvl]));
		Serial.print(F(": "));
		Serial.println(msg);
		Serial.print(F("master_mask  :")); report_line(master_mask_line);
		Serial.print(F("actual_line  :")); report_line(actual_line);
		Serial.print(F("fetched_line :")); report_line(fetched_line);
		Serial.print(F("test_case    :")); report_line(test_case);
		Serial.print(F("test_line    :")); report_line(test_line);
		Serial.print(F("cached_line  :")); report_line(cached_line);
		Serial.print(F("result_line  :")); report_line(result_line);
	};
	if (log_targets & TG_OLED) /* OLED.write(msg) TODO */;
LATER("logging to OLED")
	return true;
};	// }}}
bool C_Engine::trace(const char *msg) { 	// {{{ over detailed info
	return do_log(V_TRACE,msg);
};	// }}}
bool C_Engine::debug(const char *msg) { 	// {{{ over detailed info
	return do_log(V_DEBUG,msg);
};	// }}}
bool C_Engine::info(const char *msg) { 	// {{{ detailed info
	return do_log(V_INFO,msg);
};	// }}}
bool C_Engine::milestone(const char *msg) { 	// {{{ most important points
	return do_log(V_MILESTONE,msg);
};	// }}}
bool C_Engine::error(const char *msg) { 	// {{{ errors
	return do_log(V_ERROR,msg);
};	// }}}

bool C_Engine::do_log(uint8_t lvl,const char *msg,uint16_t number) { 	// {{{ logging also line and unit and result
	if (verbosity<lvl) return false;
	if (log_targets & TG_LED) /* LED=RED TODO */;
LATER(logging to LED)
	if (log_targets & TG_SERIAL) {
		Serial.print(FF(Levels[lvl]));
		Serial.print(F(": "));
		Serial.print(msg);
		Serial.print(F(" ("));
		Serial.print(number);
		Serial.println(F(")"));
		Serial.print(F("master_mask  :")); report_line(master_mask_line);
		Serial.print(F("actual_line  :")); report_line(actual_line);
		Serial.print(F("fetched_line :")); report_line(fetched_line);
		Serial.print(F("test_case    :")); report_line(test_case);
		Serial.print(F("test_line    :")); report_line(test_line);
		Serial.print(F("cached_line  :")); report_line(cached_line);
		Serial.print(F("result_line  :")); report_line(result_line);
		};
	if (log_targets & TG_OLED) /* OLED.write(msg) TODO */;
LATER(logging to OLED)
	return true;
};	// }}}
bool C_Engine::trace(const char *msg,uint16_t number) { 	// {{{ over detailed info
	return do_log(V_TRACE,msg, number);
};	// }}}
bool C_Engine::debug(const char *msg,uint16_t number) { 	// {{{ over detailed info
	return do_log(V_DEBUG,msg, number);
};	// }}}
bool C_Engine::info(const char *msg,uint16_t number) { 	// {{{ detailed info
	return do_log(V_INFO,msg, number);
};	// }}}
bool C_Engine::milestone(const char *msg,uint16_t number) { 	// {{{ most important points
	return do_log(V_MILESTONE,msg, number);
};	// }}}
bool C_Engine::error(const char *msg,uint16_t number) { 	// {{{ errors
	return do_log(V_ERROR,msg, number);
};	// }}}
//	}}} LOGGING
//	{{{ PROGMEM LOGGING
bool C_Engine::do_log(uint8_t lvl,const __FlashStringHelper *msg) { 	// {{{ logging also line and unit and result
	if (verbosity<lvl) return false;
	if (log_targets & TG_LED) /* LED=RED TODO */;
LATER("logging to LED")
	if (log_targets & TG_SERIAL) {
		Serial.print(FF(Levels[lvl]));
		Serial.print(F(": "));
		Serial.println(msg);
		Serial.print(F("master_mask  :")); report_line(master_mask_line);
		Serial.print(F("actual_line  :")); report_line(actual_line);
		Serial.print(F("fetched_line :")); report_line(fetched_line);
		Serial.print(F("test_case    :")); report_line(test_case);
		Serial.print(F("test_line    :")); report_line(test_line);
		Serial.print(F("cached_line  :")); report_line(cached_line);
		Serial.print(F("result_line  :")); report_line(result_line);
	};
	if (log_targets & TG_OLED) /* OLED.write(msg) TODO */;
LATER("logging to OLED")
	return true;
};	// }}}
bool C_Engine::trace(const __FlashStringHelper *msg) { 	// {{{ over detailed info
	return do_log(V_TRACE,msg);
};	// }}}
bool C_Engine::debug(const __FlashStringHelper *msg) { 	// {{{ over detailed info
	return do_log(V_DEBUG,msg);
};	// }}}
bool C_Engine::info(const __FlashStringHelper *msg) { 	// {{{ detailed info
	return do_log(V_INFO,msg);
};	// }}}
bool C_Engine::milestone(const __FlashStringHelper *msg) { 	// {{{ most important points
	return do_log(V_MILESTONE,msg);
};	// }}}
bool C_Engine::error(const __FlashStringHelper *msg) { 	// {{{ errors
	return do_log(V_ERROR,msg);
};	// }}}

bool C_Engine::do_log(uint8_t lvl,const __FlashStringHelper *msg,uint16_t number) { 	// {{{ logging also line and unit and result
	if (verbosity<lvl) return false;
	if (log_targets & TG_LED) /* LED=RED TODO */;
LATER(logging to LED)
	if (log_targets & TG_SERIAL) {
		Serial.print(FF(Levels[lvl]));
		Serial.print(F(": "));
		Serial.print(msg);
		Serial.print(F(" ("));
		Serial.print(number);
		Serial.println(F(")"));
		Serial.print(F("master_mask  :")); report_line(master_mask_line);
		Serial.print(F("actual_line  :")); report_line(actual_line);
		Serial.print(F("fetched_line :")); report_line(fetched_line);
		Serial.print(F("test_case    :")); report_line(test_case);
		Serial.print(F("test_line    :")); report_line(test_line);
		Serial.print(F("cached_line  :")); report_line(cached_line);
		Serial.print(F("result_line  :")); report_line(result_line);
		};
	if (log_targets & TG_OLED) /* OLED.write(msg) TODO */;
LATER(logging to OLED)
	return true;
};	// }}}
bool C_Engine::trace(const __FlashStringHelper *msg,uint16_t number) { 	// {{{ over detailed info
	return do_log(V_TRACE,msg, number);
};	// }}}
bool C_Engine::debug(const __FlashStringHelper *msg,uint16_t number) { 	// {{{ over detailed info
	return do_log(V_DEBUG,msg, number);
};	// }}}
bool C_Engine::info(const __FlashStringHelper *msg,uint16_t number) { 	// {{{ detailed info
	return do_log(V_INFO,msg, number);
};	// }}}
bool C_Engine::milestone(const __FlashStringHelper *msg,uint16_t number) { 	// {{{ most important points
	return do_log(V_MILESTONE,msg, number);
};	// }}}
bool C_Engine::error(const __FlashStringHelper *msg,uint16_t number) { 	// {{{ errors
	return do_log(V_ERROR,msg, number);
};	// }}}
//	}}} LOGGING
bool C_Engine::reset(uint8_t a_pins, uint16_t drivenOuts, uint16_t knownInputs) { 	// {{{ reset engine for new test batch
	unit_no=0;
	unit_skipped=0;
	unit_failed=0;
	line_no=0;
	memset(tested_outputs,' ',BUS_LEN);
	memset(tested_inputs,' ',BUS_LEN);
	for (uint8_t i=0;i<BUS_LEN-2;i++) {	// BUS_LEN-2 = active pins (not G or V) /* FIXME*/
		if (pins[i]==0xFF) {
			cached_line[i]='N';
		} else {
			cached_line[i]='v';
			pinMode(pins[i],INPUT);
		}
	};
	//	temporary hack /* FIXME */
	num_pins=a_pins;
	num_active_pins=num_pins-2; // Power
	dO=drivenOuts;
	kI=knownInputs;
			if (debug(F("C_Engine::reset"))) {
				Serial.print(F(" (pins="));
				Serial.print(a_pins);
				Serial.print(F(", drivenOuts= 0b"));
				Serial.print(drivenOuts,BIN);
				Serial.print(F(", knownInputs= 0b"));
				Serial.print(knownInputs,BIN);
				Serial.print(F(") => num_pins= "));
				Serial.print(num_pins);
				Serial.print(F(", dO= 0b"));
				Serial.print(dO,BIN);
				Serial.print(F(", kI= 0b"));
				Serial.println(kI,BIN);
			};
LATER("BUS_LEN do reset()")
	/* FIXME to BUS_LEN
	for (uint8_t i=0;i<BUS_LEN-1;i++) if (drivenOuts & _BV(i)) tested_outputs[i+1]='O';
	for (uint8_t i=0;i<BUS_LEN-1;i++) if (knownInputs & _BV(i)) tested_inputs[i+1]='I';
	*/
	
	return true;
};	// }}} 
bool C_Engine::unit_reset(const S_Unit *a_unit) { 	// {{{ reset engine for unit
	num_active_pins=num_pins-2; // Power /* FIXME to BUS_LEN */
	num_NC_pins=0; // all connected
	++unit_no;
	unit=a_unit;
	if (debug(F("\nunit_reset unit"),unit_no)) { Serial.print(FF(unit->name)); Serial.print(F(" : ")); Serial.println(FF(unit->comment));};
	if (filter_by_mask) {
		bool ok=true;
		if (unit->TP != num_pins) {
			debug(F("Bad total number of pins"),unit->TP);
			ok=false;
		};
		if (unit->AP != num_active_pins) {
			debug(F("Bad actual number of pins"),unit->AP);
			ok=false;
		};
	/* FIXME - BUS_LEN */
LATER("BUS_LEN do unit_reset()")
		if ((unit->test_inputs_mask & kI) != unit->test_inputs) {
			if (debug(F("Masked out for Inputs"))) {
				Serial.print(kI,BIN);
				Serial.print(F(" & "));
				Serial.print(unit->test_inputs_mask,BIN);
				Serial.print(F(" == "));
				Serial.print(unit->test_inputs_mask & kI,BIN);
				Serial.print(F(" != "));
				Serial.println(unit->test_inputs,BIN);
			};
			ok=false;
		};
		if ((unit->test_outputs_mask & dO) != unit->test_outputs) {
			if (debug(F("Masked out for Outputs"))) {
				Serial.print(dO,BIN);
				Serial.print(F(" & "));
				Serial.print(unit->test_outputs_mask,BIN);
				Serial.print(F(" == "));
				Serial.print(unit->test_outputs_mask & dO,BIN);
				Serial.print(F(" != "));
				Serial.println(unit->test_outputs,BIN);
			};
			ok=false;
		};
		if (!ok) return false;
	};
	line=unit->start;
	max_line=unit->end;
	line_no=0;
	// engine settings - empty all caches for unit
	memset(master_mask_line,' ',BUS_LEN);
	memset(actual_line,' ',BUS_LEN);
	memset(fetched_line,' ',BUS_LEN);
	memset(test_case,' ',BUS_LEN);
	memset(test_line,' ',BUS_LEN);
	counter_runs=false;
	counter=0;
	return true;
};	// }}} 
bool C_Engine::decode_line(const S_Line *&a_line) { 	// {{{ decode and apply line (move a_line to next place) (a_line is source, engine T_Buses are target)
	uint8_t linelen;
	linelen=decoder->fillP(a_line,&actual_line[0]);
	if (debug(F("decoded line"),line_no)) report_line(actual_line);
	if (linelen>=num_active_pins) {
		debug(F("Full line"),linelen);
		for (uint8_t i=0;i<BUS_LEN;++i) if (fetched_line[i] != 'N' ) fetched_line[i]=' ';
		//memset(fetched_line,' ',BUS_LEN);
	};
		// fully defined line, forget Xs, Fs and such, empty fetched_line, ... then continue as usual
	char c;
	uint8_t j=0;
	debug(F("linelen"),linelen);
	if (linelen==1 && actual_line[0]=='R') { 	// just repeat last line, no changes
		debug(F("R=Repeat"));
	} else {
		for (uint8_t i=0;i<linelen;++i) {
//			debug(F("climbing i"),i);
//			debug(F("    j"),j);
			c=fetched_line[j];
//			debug(F("fetched_line[j]="),c);
			while ((c!=' ')&&(c!=0)) {
				test_case[j++]=c;	// copy fetched values
				c=fetched_line[j];
//				debug(F("copy fetched"),c);
			};
			if (c==0) {
				error(F("overfilled test_case at actual_line"),i);
				return false;	// we crashed hard
			};
			c=actual_line[i];
//			debug(F("actual_line[i]="),c);
//			debug(F("    j"),j);
			if (c=='F') fetched_line[j]=test_case[j];	// fetch and leave in place
			else if (c=='X') fetched_line[j]=test_case[j]=c;	// ignore this pin on tests
			else if (c=='N') {fetched_line[j]=test_case[j]=c;--num_active_pins;++num_NC_pins;}	// Unconnect this pin forever
			else if (c=='G'||c=='V') --j;	// just ignore Power lines (we will ++j later)	/* FIXME */
			else test_case[j]=c;	// ok, we have a value
			++j;	// filled output, move pointer
//			debug(F("  ++j"),j);
		};
//		debug(F("rest of line: j"),j);
		c=fetched_line[j];	// copy rest of fetched chars at the end of line
//		debug(F("fetched_line[j]="),c);
		while ((c!=' ')&&(c!=0)) {
			test_case[j++]=c;	// copy fetched values
			c=fetched_line[j];
		};
//		debug(F("finished: j"),j);
//		debug(F("    c="),c);
		if (j<num_active_pins+num_NC_pins) {
			error(F("uderfilled test_case at actual_line"),j);
			return false;	// we crashed hard
		};
		if (j>num_active_pins+num_NC_pins) {
			error(F("overfilled test_case at actual_line"),j);
			return false;	// we crashed hard
		};
	};	// not R=Repeat
	debug(F("filled OK test_case at actual_line"));
	return true;
	
};	// }}} 
bool C_Engine::run_current_line() { 	// {{{ run tests on current line
	char c,cc;
	bool have_counter=false;
	uint8_t phases=_BV(P_INPUTS)|_BV(P_VALUES);
	bool ok=true;
	if (counter_runs) ++counter;
	for (uint8_t i=0;i<num_active_pins+num_NC_pins;++i) {
		c=test_case[i];
		cc=c ^ 0x80;
		if (c > 0x80 ) {	// counters?
			if ((cc>='a' && cc<='d') || (cc>='A' && cc<='D')) {	// counters!!
				have_counter=true;
				if (!counter_runs) {
					counter_runs=true;
					counter=0;
				};
				if (cc<'a') {	// A..D
					c=(counter & _BV(cc-'A'))?'^':'v';
				} else {
					c=(counter & _BV(cc-'a'))?'v':'^';
				};
			};
		};
		test_line[i]=c;
		if (c=='c' || c=='C') phases|=_BV(P_PREPARE)|_BV(P_EDGE)|_BV(P_CLOCK);
		if (c=='e' || c=='E') phases|=_BV(P_PREPARE)|_BV(P_EDGE);
		if (c=='Z' ) phases|=_BV(P_3STATE);
	};
	if(counter_runs && !have_counter) counter_runs=false;
	for (uint8_t i=0;i<8;++i) if (ok && (phases & _BV(i))) {
		ok=run_current_line(i);
		for (uint8_t j=0;j<num_active_pins+num_NC_pins;++j) result_line[j]=GetPin(j,'^')?'^':'v';
		trace(F("result of phase"),i);
	};
	if (ok) debug(F("run_current_line OK")); else
	error(F("run_current_line FAILED"));
	return ok;
};	// }}} 
bool C_Engine::run_current_line(uint8_t phase) { 	// {{{ run tests on current line in phase (like edge/clock/values/ ...)
	bool ok=true;
	trace(F("try run_current_line(phase)"),phase);
	switch (phase) {
		case P_INPUTS:	// first set known inputs to their values
			for (uint8_t i=0;i<num_active_pins+num_NC_pins;++i) {
				char c=test_line[i];
				switch(c){
					case '^':case 'v': case '0':case '1':SetPin(i,c);break;
					case 'L':case 'Z': case '3': SetPin(i,'^');break;
					case 'H':SetPin(i,'v');break;
				};
			};
			break;
		case P_PREPARE:	// then ensure, that clocks/edges starts where tey are supposed to
			for (uint8_t i=0;i<num_active_pins+num_NC_pins;++i) {
				char c=test_line[i];
				switch(c){
					case 'C':case 'E': SetPin(i,'v');break; 	//positive clock from LOW to HIGH and back
					case 'c':case 'e': SetPin(i,'^');break; 	//negative clock from HIGH to LOW and back
				};
			};
			
			break;
		case P_EDGE:	// do the edge (rising for CAPITAL, falling for small
			for (uint8_t i=0;i<num_active_pins+num_NC_pins;++i) {
				char c=test_line[i];
				switch(c){
					case 'C':case 'E': SetPin(i,'^');break; 	//positive clock from LOW to HIGH and back
					case 'c':case 'e': SetPin(i,'v');break; 	//negative clock from HIGH to LOW and back
				};
			};
			break;
		case P_CLOCK:	// clock goes also back, edge stay there
			for (uint8_t i=0;i<num_active_pins+num_NC_pins;++i) {
				char c=test_line[i];
				switch(c){
					case 'C': SetPin(i,'v');break; 	//positive clock from LOW to HIGH and back
					case 'c': SetPin(i,'^');break; 	//negative clock from HIGH to LOW and back
				};
			};
			
			break;
		case P_VALUES:	// check, that Outputs are driven 
			for (uint8_t i=0;i<num_active_pins+num_NC_pins;++i) {
				char c=test_line[i];
				switch(c){
					case '^':case 'H': if (GetPin(i,'v')) {
							Serial.print("! pin ");
							Serial.print(i);
							Serial.print(" char ");
							Serial.print(c);
							Serial.print(" GetPin ");
							Serial.print(GetPin(i,'v'));
							Serial.println("! ");
							ok=false;
						};
						break;
					case 'v':case 'L': case '3': if (GetPin(i,'^')) {
							Serial.print("! pin ");
							Serial.print(i);
							Serial.print(" char ");
							Serial.print(c);
							Serial.print(" GetPin ");
							Serial.print(GetPin(i,'^'));
							Serial.println("! ");
							ok = false;
						};
						break; // 3state are set ^ initially
				};
			};
			
			break;
		case P_3STATE:
			for (uint8_t i=0;i<num_active_pins+num_NC_pins;++i) {
				if ('3'==test_line[i]) { SetPin(i,'v');  if (GetPin(i,'^')) ok = false; }
			};
			
			break;
	};
	trace(F("PASSED run_current_line(phase)"),phase);
	return ok; 	// nothing failed, so it is OK
};	// }}} 
bool C_Engine::run_test() { 	// {{{ run test on current unit
	if (debug(F("runtest on unit"),unit_no)) Serial.println(FF(unit->name));
	bool ok=true;
	while (line<max_line) {
//#	Serial.print(F("RT:"));
//#	Serial.print((long unsigned int)line,HEX);
//#	Serial.print(F(".."));
//#	Serial.print((long unsigned int)max_line,HEX);
		if (! decode_line(line)) {
			error(F("Failed decode_line, test failed at"),line_no);
			return false;
		};
		if (!run_current_line()) {
			++unit_failed;
			ok=false;
			if (debug(F("FAILED runtest on unit"),unit_no)) Serial.println(FF(unit->name));
			debug(F("on line"),line_no);
			if (!run_all_lines) return false;
		};
		++line_no;
	};
	report_unit();
	return ok;
};	// }}} 
bool C_Engine::run_range(const S_Unit *start, const S_Unit *end) { 	// {{{ run tests on units in range
	while (start!=end) {
		if (!unit_reset(start++)) {
			++unit_skipped;
			continue;
		};
		if (run_test()) {
			return true;
		} else {
			++unit_failed;
		};
	};
	return false;
};	// }}} 
void C_Engine::report_unit() {	// {{{ report actual unit
	if (milestone(F("RESULT: unit"),unit_no)) { 
		Serial.print(F("Chip found as :"));
		Serial.print(FF(unit->name));
		Serial.print(F(" : "));
		Serial.println(FF(unit->comment));
		};
};	// }}} 
const __FlashStringHelper *C_Engine::get_unit_name(uint16_t u) {	// {{{
	return FF(units[u].name);
};	 // }}}
const __FlashStringHelper *C_Engine::get_unit_comment(uint16_t u) {	// {{{
	return FF(units[u].comment);
};	 // }}}
const __FlashStringHelper *C_Engine::get_unit_name() {	// {{{
	return FF(unit->name);
};	 // }}}
const __FlashStringHelper *C_Engine::get_unit_comment() {	// {{{
	return FF(unit->comment);
};	 // }}}
void C_Engine::report_line(const char *a_line) {	// {{{ converts and prints line
LATER("logging to OLED")
	if (! (log_targets & TG_SERIAL)) return;
	char c;
	for (const char *x=a_line;*x;++x) {
		c=*x;
		if (c>127){ Serial.write("@"); c&=0x7F;};
		Serial.write(c);
		};
	Serial.println();
}; 	// }}}
void C_Engine::SetPin(uint8_t pin, char value) {	// {{{ Set pin to ^v10 (consult/set cached_line if needed)
	if (cached_line[pin]==value) return;	// already done
	switch (value){
		case '^': pinMode(pins[pin],INPUT_PULLUP);break;
		case 'v': pinMode(pins[pin],INPUT);break;
		case '1': if (cached_line[pin]!='0') pinMode(pins[pin],OUTPUT);digitalWrite(pins[pin],HIGH);break;
		case '0': if (cached_line[pin]!='1') pinMode(pins[pin],OUTPUT);digitalWrite(pins[pin],LOW);break;
	};
	cached_line[pin]=value;
}; 	// }}}
bool C_Engine::GetPin(uint8_t pin, char value) {	// {{{ Return if pin really reads ^v
	return (digitalRead(pins[pin]) == (value=='^'));
}; 	// }}}
// }}} C_Engine
